texture vd_srctexture;
float4 vd_texsize;
float gamma <
	bool vd_tunable = true;
	float vd_tunablemin = 0.1f;
	float vd_tunablemax = 4.0f;
> = 1.0f;

sampler src = sampler_state {
	Texture = <vd_srctexture>;
	AddressU = clamp;
	AddressV = clamp;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};

void VS(
	float4 pos : POSITION,
	float2 t0 : TEXCOORD0,
	out float4 oPos : POSITION,
	out float2 oT0 : TEXCOORD0,
	out float2 oT1 : TEXCOORD1,
	out float2 oT2 : TEXCOORD2,
	out float2 oT3 : TEXCOORD3,
	out float2 oT4 : TEXCOORD4
)
{
	oPos = pos;
	oT0 = t0;
	oT1 = t0 + vd_texsize.wz * float2(-0.5f, -1.0f);
	oT2 = t0 + vd_texsize.wz * float2( 1.0f, -0.5f);
	oT3 = t0 + vd_texsize.wz * float2( 0.5f,  1.0f);
	oT4 = t0 + vd_texsize.wz * float2(-1.0f,  0.5f);
}

float4 PS(
	float2 t0 : TEXCOORD0,
	float2 t1 : TEXCOORD1,
	float2 t2 : TEXCOORD2,
	float2 t3 : TEXCOORD3,
	float2 t4 : TEXCOORD4
) : COLOR0
{
	float4 cen = tex2D(src, t0);
	float4 p00 = tex2D(src, t1);
	float4 p20 = tex2D(src, t2);
	float4 p02 = tex2D(src, t3);
	float4 p22 = tex2D(src, t4);

	float4 predicted = (p00 + p20 + p02 + p22) * 0.25f;
	float lerpFactor = saturate(1.5 - length(predicted - cen) * 127.0f);

	cen = lerp(cen, predicted, lerpFactor);	

	return float4(pow(cen.rgb, gamma), cen.a);
}

technique {
	pass {
		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	}
}
