texture vd_srctexture;
float4 vd_texsize;
float threshold <
	bool vd_tunable = true;
	float vd_tunablemin = 0.0f;
	float vd_tunablemax = 1.0f;
> = 0.5f;

sampler src = sampler_state {
	Texture = <vd_srctexture>;
	AddressU = clamp;
	AddressV = clamp;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};

void VS(
	float4 pos : POSITION,
	float2 t0 : TEXCOORD0,
	out float4 oPos : POSITION,
	out float2 oT0 : TEXCOORD0
)
{
	oPos = pos;
	oT0 = t0;
}

float4 PS(
	float2 t0 : TEXCOORD0
) : COLOR0
{
	float4 p0 = tex2D(src, t0);

	static const float3 lumacoeff = {0.30, 0.59, 0.11};

	return dot(p0.xyz, lumacoeff) > threshold;
}

technique {
	pass {
		VertexShader = compile vs_2_0 VS();
		PixelShader = compile ps_2_0 PS();
	}
}
